/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;

import com.ibm.etools.c.datatypes.CBitField;
import com.ibm.etools.c.datatypes.CBoolean;
import com.ibm.etools.c.datatypes.CChar;
import com.ibm.etools.c.datatypes.CDirectionKind;
import com.ibm.etools.c.datatypes.CDouble;
import com.ibm.etools.c.datatypes.CEnumeration;
import com.ibm.etools.c.datatypes.CFloat;
import com.ibm.etools.c.datatypes.CInt;
import com.ibm.etools.c.datatypes.CLong;
import com.ibm.etools.c.datatypes.CLongDouble;
import com.ibm.etools.c.datatypes.CLongLong;
import com.ibm.etools.c.datatypes.CShort;
import com.ibm.etools.c.datatypes.CSignedChar;
import com.ibm.etools.c.datatypes.CUnsignedChar;
import com.ibm.etools.c.datatypes.CUnsignedInt;
import com.ibm.etools.c.datatypes.CUnsignedLong;
import com.ibm.etools.c.datatypes.CUnsignedLongLong;
import com.ibm.etools.c.datatypes.CUnsignedShort;
import com.ibm.etools.c.datatypes.CVoid;
import com.ibm.etools.c.datatypes.CWchar;
import com.ibm.etools.c.datatypes.DatatypesFactory;
import com.ibm.etools.c.datatypes.DatatypesPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory </b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class DatatypesFactoryImpl extends EFactoryImpl implements DatatypesFactory {
    /**
     * Creates and instance of the factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public DatatypesFactoryImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EObject create(EClass eClass) {
        switch (eClass.getClassifierID()) {
        case DatatypesPackage.CLONG_DOUBLE:
            return createCLongDouble();
        case DatatypesPackage.CFLOAT:
            return createCFloat();
        case DatatypesPackage.CUNSIGNED_SHORT:
            return createCUnsignedShort();
        case DatatypesPackage.CDOUBLE:
            return createCDouble();
        case DatatypesPackage.CSHORT:
            return createCShort();
        case DatatypesPackage.CUNSIGNED_LONG_LONG:
            return createCUnsignedLongLong();
        case DatatypesPackage.CLONG_LONG:
            return createCLongLong();
        case DatatypesPackage.CUNSIGNED_LONG:
            return createCUnsignedLong();
        case DatatypesPackage.CLONG:
            return createCLong();
        case DatatypesPackage.CUNSIGNED_CHAR:
            return createCUnsignedChar();
        case DatatypesPackage.CCHAR:
            return createCChar();
        case DatatypesPackage.CVOID:
            return createCVoid();
        case DatatypesPackage.CWCHAR:
            return createCWchar();
        case DatatypesPackage.CINT:
            return createCInt();
        case DatatypesPackage.CUNSIGNED_INT:
            return createCUnsignedInt();
        case DatatypesPackage.CBIT_FIELD:
            return createCBitField();
        case DatatypesPackage.CSIGNED_CHAR:
            return createCSignedChar();
        case DatatypesPackage.CENUMERATION:
            return createCEnumeration();
        default:
            throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object createFromString(EDataType eDataType, String initialValue) {
        switch (eDataType.getClassifierID()) {
        case DatatypesPackage.CBOOLEAN:
            return CBoolean.get(initialValue);
        case DatatypesPackage.CDIRECTION_KIND:
            return CDirectionKind.get(initialValue);
        case DatatypesPackage.CSTRING:
            return createCStringFromString(eDataType, initialValue);
        case DatatypesPackage.CINTEGER:
            return createCIntegerFromString(eDataType, initialValue);
        default:
            throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String convertToString(EDataType eDataType, Object instanceValue) {
        switch (eDataType.getClassifierID()) {
        case DatatypesPackage.CBOOLEAN:
            return instanceValue == null ? null : instanceValue.toString();
        case DatatypesPackage.CDIRECTION_KIND:
            return instanceValue == null ? null : instanceValue.toString();
        case DatatypesPackage.CSTRING:
            return convertCStringToString(eDataType, instanceValue);
        case DatatypesPackage.CINTEGER:
            return convertCIntegerToString(eDataType, instanceValue);
        default:
            throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CLongDouble createCLongDouble() {
        CLongDoubleImpl cLongDouble = new CLongDoubleImpl();
        return cLongDouble;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CFloat createCFloat() {
        CFloatImpl cFloat = new CFloatImpl();
        return cFloat;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CUnsignedShort createCUnsignedShort() {
        CUnsignedShortImpl cUnsignedShort = new CUnsignedShortImpl();
        return cUnsignedShort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CDouble createCDouble() {
        CDoubleImpl cDouble = new CDoubleImpl();
        return cDouble;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CShort createCShort() {
        CShortImpl cShort = new CShortImpl();
        return cShort;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CUnsignedLongLong createCUnsignedLongLong() {
        CUnsignedLongLongImpl cUnsignedLongLong = new CUnsignedLongLongImpl();
        return cUnsignedLongLong;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CLongLong createCLongLong() {
        CLongLongImpl cLongLong = new CLongLongImpl();
        return cLongLong;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CUnsignedLong createCUnsignedLong() {
        CUnsignedLongImpl cUnsignedLong = new CUnsignedLongImpl();
        return cUnsignedLong;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CLong createCLong() {
        CLongImpl cLong = new CLongImpl();
        return cLong;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CUnsignedChar createCUnsignedChar() {
        CUnsignedCharImpl cUnsignedChar = new CUnsignedCharImpl();
        return cUnsignedChar;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CChar createCChar() {
        CCharImpl cChar = new CCharImpl();
        return cChar;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CVoid createCVoid() {
        CVoidImpl cVoid = new CVoidImpl();
        return cVoid;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CWchar createCWchar() {
        CWcharImpl cWchar = new CWcharImpl();
        return cWchar;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CInt createCInt() {
        CIntImpl cInt = new CIntImpl();
        return cInt;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CUnsignedInt createCUnsignedInt() {
        CUnsignedIntImpl cUnsignedInt = new CUnsignedIntImpl();
        return cUnsignedInt;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CBitField createCBitField() {
        CBitFieldImpl cBitField = new CBitFieldImpl();
        return cBitField;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CSignedChar createCSignedChar() {
        CSignedCharImpl cSignedChar = new CSignedCharImpl();
        return cSignedChar;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CEnumeration createCEnumeration() {
        CEnumerationImpl cEnumeration = new CEnumerationImpl();
        return cEnumeration;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String createCStringFromString(EDataType eDataType, String initialValue) {
        return (String) super.createFromString(eDataType, initialValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String convertCStringToString(EDataType eDataType, Object instanceValue) {
        return super.convertToString(eDataType, instanceValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String createCIntegerFromString(EDataType eDataType, String initialValue) {
        return (String) super.createFromString(eDataType, initialValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String convertCIntegerToString(EDataType eDataType, Object instanceValue) {
        return super.convertToString(eDataType, instanceValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public DatatypesPackage getDatatypesPackage() {
        return (DatatypesPackage) getEPackage();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @deprecated @generated
     */
    public static DatatypesPackage getPackage() {
        return DatatypesPackage.eINSTANCE;
    }
} //DatatypesFactoryImpl
