/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.util;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.etools.c.CArray;
import com.ibm.etools.c.CBehavioralFeature;
import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDatatype;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CEnumerator;
import com.ibm.etools.c.CField;
import com.ibm.etools.c.CFunction;
import com.ibm.etools.c.CInitializer;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CParameter;
import com.ibm.etools.c.CPointer;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CStruct;
import com.ibm.etools.c.CStructuralFeature;
import com.ibm.etools.c.CStructureContents;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.c.CTypedElement;
import com.ibm.etools.c.CTypedef;
import com.ibm.etools.c.CUnion;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangComposedType;
import com.ibm.etools.tdlang.TDLangElement;
import com.ibm.etools.tdlang.TDLangModelElement;

/**
 * <!-- begin-user-doc --> The <b>Switch </b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch doSwitch(object)}to invoke
 * the <code>caseXXX</code> method for each class of the model, starting with
 * the actual class of the object and proceeding up the inheritance hierarchy
 * until a non-null result is returned, which is the result of the switch. <!--
 * end-user-doc -->
 * 
 * @see com.ibm.etools.c.CPackage
 * @generated
 */
public class CSwitch {
    /**
     * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static CPackage modelPackage;

    /**
     * Creates an instance of the switch. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public CSwitch() {
        if (modelPackage == null) {
            modelPackage = CPackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one
     * returns a non null result; it yields that result. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the first non-null result returned by a <code>caseXXX</code>
     *         call.
     * @generated
     */
    public Object doSwitch(EObject theEObject) {
        EClass theEClass = theEObject.eClass();
        if (theEClass.eContainer() == modelPackage) {
            switch (theEClass.getClassifierID()) {
            case CPackage.CSTRUCT: {
                CStruct cStruct = (CStruct) theEObject;
                Object result = caseCStruct(cStruct);
                if (result == null)
                    result = caseCStructured(cStruct);
                if (result == null)
                    result = caseTDLangComposedType(cStruct);
                if (result == null)
                    result = caseCClassifier(cStruct);
                if (result == null)
                    result = caseCStructureContents(cStruct);
                if (result == null)
                    result = caseCDerivableType(cStruct);
                if (result == null)
                    result = caseTDLangClassifier(cStruct);
                if (result == null)
                    result = caseTDLangModelElement(cStruct);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CUNION: {
                CUnion cUnion = (CUnion) theEObject;
                Object result = caseCUnion(cUnion);
                if (result == null)
                    result = caseCStructured(cUnion);
                if (result == null)
                    result = caseTDLangComposedType(cUnion);
                if (result == null)
                    result = caseCClassifier(cUnion);
                if (result == null)
                    result = caseCStructureContents(cUnion);
                if (result == null)
                    result = caseCDerivableType(cUnion);
                if (result == null)
                    result = caseTDLangClassifier(cUnion);
                if (result == null)
                    result = caseTDLangModelElement(cUnion);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CPARAMETER: {
                CParameter cParameter = (CParameter) theEObject;
                Object result = caseCParameter(cParameter);
                if (result == null)
                    result = caseCTypedElement(cParameter);
                if (result == null)
                    result = caseTDLangElement(cParameter);
                if (result == null)
                    result = caseTDLangModelElement(cParameter);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CTYPEDEF: {
                CTypedef cTypedef = (CTypedef) theEObject;
                Object result = caseCTypedef(cTypedef);
                if (result == null)
                    result = caseCDerived(cTypedef);
                if (result == null)
                    result = caseCClassifier(cTypedef);
                if (result == null)
                    result = caseCDerivableType(cTypedef);
                if (result == null)
                    result = caseTDLangClassifier(cTypedef);
                if (result == null)
                    result = caseTDLangModelElement(cTypedef);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CARRAY: {
                CArray cArray = (CArray) theEObject;
                Object result = caseCArray(cArray);
                if (result == null)
                    result = caseCDerived(cArray);
                if (result == null)
                    result = caseCClassifier(cArray);
                if (result == null)
                    result = caseCDerivableType(cArray);
                if (result == null)
                    result = caseTDLangClassifier(cArray);
                if (result == null)
                    result = caseTDLangModelElement(cArray);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CPOINTER: {
                CPointer cPointer = (CPointer) theEObject;
                Object result = caseCPointer(cPointer);
                if (result == null)
                    result = caseCDerived(cPointer);
                if (result == null)
                    result = caseCClassifier(cPointer);
                if (result == null)
                    result = caseCDerivableType(cPointer);
                if (result == null)
                    result = caseTDLangClassifier(cPointer);
                if (result == null)
                    result = caseTDLangModelElement(cPointer);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CENUMERATOR: {
                CEnumerator cEnumerator = (CEnumerator) theEObject;
                Object result = caseCEnumerator(cEnumerator);
                if (result == null)
                    result = caseCInitializer(cEnumerator);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CFIELD: {
                CField cField = (CField) theEObject;
                Object result = caseCField(cField);
                if (result == null)
                    result = caseCStructuralFeature(cField);
                if (result == null)
                    result = caseCTypedElement(cField);
                if (result == null)
                    result = caseCStructureContents(cField);
                if (result == null)
                    result = caseTDLangElement(cField);
                if (result == null)
                    result = caseTDLangModelElement(cField);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CFUNCTION: {
                CFunction cFunction = (CFunction) theEObject;
                Object result = caseCFunction(cFunction);
                if (result == null)
                    result = caseCBehavioralFeature(cFunction);
                if (result == null)
                    result = caseCDerivableType(cFunction);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CINITIALIZER: {
                CInitializer cInitializer = (CInitializer) theEObject;
                Object result = caseCInitializer(cInitializer);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case CPackage.CSOURCE_TEXT: {
                CSourceText cSourceText = (CSourceText) theEObject;
                Object result = caseCSourceText(cSourceText);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            default:
                return defaultCase(theEObject);
            }
        }
        return defaultCase(theEObject);
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Classifier</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Classifier</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCClassifier(CClassifier object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Structured</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Structured</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCStructured(CStructured object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Struct</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Struct</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCStruct(CStruct object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Union</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Union</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnion(CUnion object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Behavioral Feature</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Behavioral Feature</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCBehavioralFeature(CBehavioralFeature object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Typed Element</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Typed Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCTypedElement(CTypedElement object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Structural Feature</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Structural Feature</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCStructuralFeature(CStructuralFeature object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Parameter</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Parameter</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCParameter(CParameter object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Datatype</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Datatype</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDatatype(CDatatype object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Typedef</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Typedef</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCTypedef(CTypedef object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Derived</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Derived</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDerived(CDerived object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Array</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Array</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCArray(CArray object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Pointer</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Pointer</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCPointer(CPointer object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Enumerator</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Enumerator</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCEnumerator(CEnumerator object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Field</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Field</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCField(CField object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Function</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Function</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCFunction(CFunction object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Initializer</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Initializer</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCInitializer(CInitializer object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Derivable Type</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Derivable Type</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDerivableType(CDerivableType object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Structure Contents</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Structure Contents</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCStructureContents(CStructureContents object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Source Text</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Source Text</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCSourceText(CSourceText object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Model Element</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Model Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangModelElement(TDLangModelElement object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Classifier</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Classifier</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangClassifier(TDLangClassifier object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Composed Type</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Composed Type</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangComposedType(TDLangComposedType object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Element</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangElement(TDLangElement object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch, but this is
     * the last case anyway. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public Object defaultCase(EObject object) {
        return null;
    }

} //CSwitch
