// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<PART NUMBER - 5724-B75>>
//   (C) Copyright IBM Corp. 1999, 2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************
package com.ibm.etools.marshall.util;

/**
 * This interface defines the behavior for a range of values.  This
 * interface is intended to be used with the possible value construct
 * on a field.
 */

public interface IRangeObject extends java.io.Serializable, Cloneable
{
public static String copyright = "(c) Copyright IBM Corporation 1999, 2004.";
/**
 * Creates a new object of the same class as this object. It then initializes
 * each of the new object's fields by assigning it the same value as
 * the corresponding field in this object. No constructor is called.
 * @return A new object initialized to the same state as this object.
 */

public Object clone();


/**
 * Returns the lower range, or bounds, of the range object.
 * @return The lower range, or bounds, of the range object.
 */

public Object getLowerRange();


/**
 * Returns the upper range, or bounds, of the range object.
 * @return The upper range, or bounds, of the range object.
 */

public Object getUpperRange();


/**
 * Tests whether the specified value lies within the upper and lower range
 * set on the range object.
 * @return <code>true</code> if the specified value lies within the upper
 * and lower range; <code>false</code> otherwise.
 * @param value The value to compare against.
 */

public boolean isInRange (Object value);


/**
 * Sets the lower range, or bounds, of the range object.
 * @param value The lower range value.
 * @exception IllegalArgumentException The value specified is not valid for
 * this range object.
 */

public void setLowerRange (Object value) throws IllegalArgumentException;


/**
 * Sets the upper range, or bounds, of the range object.
 * @param value The upper range value.
 * @exception IllegalArgumentException The value specified is not valid for
 * this range object.
 */

public void setUpperRange (Object value) throws IllegalArgumentException;
}